/* tslint:disable */
/* eslint-disable */
/**
 * MailSlurp API
 * MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It\'s designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository
 *
 * The version of the OpenAPI document: 6.5.2
 * Contact: contact@mailslurp.dev
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
  PageableObject,
  PageableObjectFromJSON,
  PageableObjectFromJSONTyped,
  PageableObjectToJSON,
  SendWithQueueResult,
  SendWithQueueResultFromJSON,
  SendWithQueueResultFromJSONTyped,
  SendWithQueueResultToJSON,
  SortObject,
  SortObjectFromJSON,
  SortObjectFromJSONTyped,
  SortObjectToJSON,
} from './';

/**
 * Paginated sent email results for emails sent with queue. Page index starts at zero. Projection results may omit larger entity fields. For fetching a full sent email entity use the projection ID with individual method calls.
 * @export
 * @interface PageSentEmailWithQueueProjection
 */
export interface PageSentEmailWithQueueProjection {
  /**
   * Collection of items
   * @type {Array<SendWithQueueResult>}
   * @memberof PageSentEmailWithQueueProjection
   */
  content: Array<SendWithQueueResult>;
  /**
   *
   * @type {PageableObject}
   * @memberof PageSentEmailWithQueueProjection
   */
  pageable?: PageableObject;
  /**
   *
   * @type {number}
   * @memberof PageSentEmailWithQueueProjection
   */
  total?: number;
  /**
   * Size of page requested
   * @type {number}
   * @memberof PageSentEmailWithQueueProjection
   */
  size: number;
  /**
   * Page number starting at 0
   * @type {number}
   * @memberof PageSentEmailWithQueueProjection
   */
  number: number;
  /**
   * Number of items returned
   * @type {number}
   * @memberof PageSentEmailWithQueueProjection
   */
  numberOfElements: number;
  /**
   * Total number of items available for querying
   * @type {number}
   * @memberof PageSentEmailWithQueueProjection
   */
  totalElements: number;
  /**
   * Total number of pages available
   * @type {number}
   * @memberof PageSentEmailWithQueueProjection
   */
  totalPages: number;
  /**
   *
   * @type {boolean}
   * @memberof PageSentEmailWithQueueProjection
   */
  last?: boolean;
  /**
   *
   * @type {SortObject}
   * @memberof PageSentEmailWithQueueProjection
   */
  sort?: SortObject;
  /**
   *
   * @type {boolean}
   * @memberof PageSentEmailWithQueueProjection
   */
  first?: boolean;
  /**
   *
   * @type {boolean}
   * @memberof PageSentEmailWithQueueProjection
   */
  empty?: boolean;
}

export function PageSentEmailWithQueueProjectionFromJSON(
  json: any
): PageSentEmailWithQueueProjection {
  return PageSentEmailWithQueueProjectionFromJSONTyped(json, false);
}

export function PageSentEmailWithQueueProjectionFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): PageSentEmailWithQueueProjection {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    content: (json['content'] as Array<any>).map(SendWithQueueResultFromJSON),
    pageable: !exists(json, 'pageable')
      ? undefined
      : PageableObjectFromJSON(json['pageable']),
    total: !exists(json, 'total') ? undefined : json['total'],
    size: json['size'],
    number: json['number'],
    numberOfElements: json['numberOfElements'],
    totalElements: json['totalElements'],
    totalPages: json['totalPages'],
    last: !exists(json, 'last') ? undefined : json['last'],
    sort: !exists(json, 'sort') ? undefined : SortObjectFromJSON(json['sort']),
    first: !exists(json, 'first') ? undefined : json['first'],
    empty: !exists(json, 'empty') ? undefined : json['empty'],
  };
}

export function PageSentEmailWithQueueProjectionToJSON(
  value?: PageSentEmailWithQueueProjection | null
): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    content: (value.content as Array<any>).map(SendWithQueueResultToJSON),
    pageable: PageableObjectToJSON(value.pageable),
    total: value.total,
    size: value.size,
    number: value.number,
    numberOfElements: value.numberOfElements,
    totalElements: value.totalElements,
    totalPages: value.totalPages,
    last: value.last,
    sort: SortObjectToJSON(value.sort),
    first: value.first,
    empty: value.empty,
  };
}
